package com.jiayue.simulation.ice102.service;

import org.springframework.stereotype.Service;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;


public abstract class CommonService {

    public void generateFile(String messageStr,Integer fileNameLength,String charset,String filePath) throws IOException {
//        // 报文用逗号分隔
//        String messageStr = "";
//        // 文件名称长度
//        Integer fileNameLength = 64;
//        // 生成文件编码格式
//        String charset = "GBK";
        messageStr = messageStr.replace(" ", "");
        String[] tempMessage = messageStr.split(",");
        String fileNameHex = "";
        StringBuffer sb = new StringBuffer("");
        for (int i = 0; i < tempMessage.length; i++) {
            // 循环每一帧的报文
            String m = tempMessage[i];
            // 获取文件内容帧
            if ("".equals(fileNameHex)) {
                fileNameHex = m.substring(26, 26 + fileNameLength * 2);
            }
            // 拼接文件内容
            sb.append(m.substring(26 + fileNameLength * 2, m.length() - 4));
        }
        // 文件名去掉尾部占位的0
        fileNameHex = fileNameHex.replaceAll("0*$", "");
        int fileNameHexLength = fileNameHex.length();
        byte[] fnData = new byte[fileNameHexLength / 2];
        for (
                int k = 0;
                k < fileNameHexLength; k += 2) {
            fnData[k / 2] = (byte) ((Character.digit(fileNameHex.charAt(k), 16) << 4)
                    + Character.digit(fileNameHex.charAt(k + 1), 16));
        }
        String filename = new String(fnData, charset);
        // 生成文件内容
        String contentStr = sb.toString();
        int fileContentHexLength = contentStr.length();
        byte[] data = new byte[fileContentHexLength / 2];
        for (
                int i = 0;
                i < fileContentHexLength; i += 2) {
            data[i / 2] = (byte) ((Character.digit(contentStr.charAt(i), 16) << 4)
                    + Character.digit(contentStr.charAt(i + 1), 16));
        }
        OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(filePath + filename), charset);
        String res = new String(data, charset);
        osw.write(res);
        osw.close();
    }
}
